#include "DatabaseHandler/DatabaseHandler.h"
#include "DatabaseHandler/Source/v2/DataClasses/PlayerPerformance.h"
#include "DatabaseHandlerTests/InMemoryDbFixture.h"

TEST_F(InMemoryDbFixture, PlayerPerformanceTests)
{
	using namespace database_handler;
	using namespace database_handler::v2;
	using namespace database_handler::common;
	
	PlayerPerformance playerPerformance1;
	playerPerformance1.sm_player_id = 1;
	playerPerformance1.sm_season_id = 2;
	playerPerformance1.sm_team_id = 3;
	playerPerformance1.number = 4;
	playerPerformance1.captain = 5;
	playerPerformance1.injured = false;
	playerPerformance1.minutes = 7;
	playerPerformance1.appearences = 8;
	playerPerformance1.lineups = 9;
	playerPerformance1.substitute_in = 10;
	playerPerformance1.substitute_out = 11;
	playerPerformance1.substitutes_on_bench = 12;
	playerPerformance1.goals = 13;
	playerPerformance1.assists = 14;
	playerPerformance1.saves_opt = 15;
	playerPerformance1.inside_box_saves_opt = 16;
	playerPerformance1.dispossesed_opt = 17;
	playerPerformance1.interceptions_opt = 18;
	playerPerformance1.yellowcards = 19;
	playerPerformance1.yellowred = 20;
	playerPerformance1.redcards = 21;
	playerPerformance1.tackles_opt = 22;
	playerPerformance1.blocks_opt = 23;
	playerPerformance1.hit_post_opt = 24;
	playerPerformance1.fouls_committed_opt = 25;
	playerPerformance1.fouls_drawn_opt = 26;
	playerPerformance1.crosses_total_opt = 27;
	playerPerformance1.crosses_accurate_opt = 28;
	playerPerformance1.dribbles_attempts_opt = 29;
	playerPerformance1.dribbles_success_opt = 30;
	playerPerformance1.dribbled_past_opt = 31;
	playerPerformance1.duels_total_opt = 32;
	playerPerformance1.duels_won_opt = 33;
	playerPerformance1.passes_total_opt = 34;
	playerPerformance1.passes_accuracy_opt = 35.36;
	playerPerformance1.key_passes_opt = 37;
	playerPerformance1.penalties_won_opt = 38;
	playerPerformance1.penalties_scored_opt = 39;
	playerPerformance1.penalties_missed_opt = 40;
	playerPerformance1.penalties_committed_opt = 41;
	playerPerformance1.penalties_saved_opt = 42;
	playerPerformance1.shots_total_opt = 43;
	playerPerformance1.shots_on_target_opt = 44;
	playerPerformance1.shots_off_target_opt = 45;
	
	PlayerPerformance playerPerformance2;
	
	PlayerPerformance playerPerformance3;
	playerPerformance3.sm_player_id = 46;
	playerPerformance3.sm_season_id = 47;
	playerPerformance3.sm_team_id = 48;
	playerPerformance3.number = 49;
	playerPerformance3.captain = 50;
	playerPerformance3.injured = true;
	playerPerformance3.minutes = 52;
	playerPerformance3.appearences = 53;
	playerPerformance3.lineups = 54;
	playerPerformance3.substitute_in = 55;
	playerPerformance3.substitute_out = 56;
	playerPerformance3.substitutes_on_bench = 57;
	playerPerformance3.goals = 58;
	playerPerformance3.assists = 59;
	playerPerformance3.saves_opt = 60;
	playerPerformance3.inside_box_saves_opt = 61;
	playerPerformance3.dispossesed_opt = 62;
	playerPerformance3.interceptions_opt = 63;
	playerPerformance3.yellowcards = 64;
	playerPerformance3.yellowred = 65;
	playerPerformance3.redcards = 66;
	playerPerformance3.tackles_opt = 67;
	playerPerformance3.blocks_opt = 68;
	playerPerformance3.hit_post_opt = 69;
	playerPerformance3.fouls_committed_opt = 70;
	playerPerformance3.fouls_drawn_opt = 71;
	playerPerformance3.crosses_total_opt = 72;
	playerPerformance3.crosses_accurate_opt = 73;
	playerPerformance3.dribbles_attempts_opt = 74;
	playerPerformance3.dribbles_success_opt = 75;
	playerPerformance3.dribbled_past_opt = 76;
	playerPerformance3.duels_total_opt = 77;
	playerPerformance3.duels_won_opt = 78;
	playerPerformance3.passes_total_opt = 79;
	playerPerformance3.passes_accuracy_opt = 80.81;
	playerPerformance3.key_passes_opt = 82;
	playerPerformance3.penalties_won_opt = 83;
	playerPerformance3.penalties_scored_opt = 84;
	playerPerformance3.penalties_missed_opt = 85;
	playerPerformance3.penalties_committed_opt = 86;
	playerPerformance3.penalties_saved_opt = 87;
	playerPerformance3.shots_total_opt = 88;
	playerPerformance3.shots_on_target_opt = 89;
	playerPerformance3.shots_off_target_opt = 90;
	
	std::vector<UpPlayerPerformance> onePlayerPerformance;
	onePlayerPerformance.emplace_back(std::make_unique<PlayerPerformance>(playerPerformance1));

	std::vector<UpPlayerPerformance> twoplayerPerformances;
	twoplayerPerformances.emplace_back(std::make_unique<PlayerPerformance>(playerPerformance1));
	twoplayerPerformances.emplace_back(std::make_unique<PlayerPerformance>(playerPerformance2));

	std::vector<UpPlayerPerformance> threeplayerPerformances;
	threeplayerPerformances.emplace_back(std::make_unique<PlayerPerformance>(playerPerformance1));
	threeplayerPerformances.emplace_back(std::make_unique<PlayerPerformance>(playerPerformance2));
	threeplayerPerformances.emplace_back(std::make_unique<PlayerPerformance>(playerPerformance3));

	EXPECT_EQ(1, onePlayerPerformance.size());
	EXPECT_EQ(2, twoplayerPerformances.size());
	EXPECT_EQ(3, threeplayerPerformances.size());

	ASSERT_NO_THROW(db.exec(CREATE_TABLE_PLAYER_PERFORMANCES));
	ASSERT_NO_THROW(InsertOr(OnConflict::Ignore, db, onePlayerPerformance));
	ASSERT_EQ(1, QueryCount<PlayerPerformance>(db));
	{
		auto playerPerformances = QueryAll<PlayerPerformance>(db);
		EXPECT_EQ(1, playerPerformances.size());

		EXPECT_NE(0, playerPerformances[0]->id);
		EXPECT_EQ(playerPerformance1.sm_player_id, playerPerformances[0]->sm_player_id);
		EXPECT_EQ(playerPerformance1.sm_season_id, playerPerformances[0]->sm_season_id);
		EXPECT_EQ(playerPerformance1.sm_team_id, playerPerformances[0]->sm_team_id);
		EXPECT_EQ(playerPerformance1.number, playerPerformances[0]->number);
		EXPECT_EQ(playerPerformance1.captain, playerPerformances[0]->captain);
		EXPECT_EQ(playerPerformance1.injured, playerPerformances[0]->injured);
		EXPECT_EQ(playerPerformance1.minutes, playerPerformances[0]->minutes);
		EXPECT_EQ(playerPerformance1.appearences, playerPerformances[0]->appearences);
		EXPECT_EQ(playerPerformance1.lineups, playerPerformances[0]->lineups);
		EXPECT_EQ(playerPerformance1.substitute_in, playerPerformances[0]->substitute_in);
		EXPECT_EQ(playerPerformance1.substitute_out, playerPerformances[0]->substitute_out);
		EXPECT_EQ(playerPerformance1.substitutes_on_bench, playerPerformances[0]->substitutes_on_bench);
		EXPECT_EQ(playerPerformance1.goals, playerPerformances[0]->goals);
		EXPECT_EQ(playerPerformance1.assists, playerPerformances[0]->assists);
		EXPECT_EQ(playerPerformance1.saves_opt, playerPerformances[0]->saves_opt);
		EXPECT_EQ(playerPerformance1.inside_box_saves_opt, playerPerformances[0]->inside_box_saves_opt);
		EXPECT_EQ(playerPerformance1.dispossesed_opt, playerPerformances[0]->dispossesed_opt);
		EXPECT_EQ(playerPerformance1.interceptions_opt, playerPerformances[0]->interceptions_opt);
		EXPECT_EQ(playerPerformance1.yellowcards, playerPerformances[0]->yellowcards);
		EXPECT_EQ(playerPerformance1.yellowred, playerPerformances[0]->yellowred);
		EXPECT_EQ(playerPerformance1.redcards, playerPerformances[0]->redcards);
		EXPECT_EQ(playerPerformance1.tackles_opt, playerPerformances[0]->tackles_opt);
		EXPECT_EQ(playerPerformance1.blocks_opt, playerPerformances[0]->blocks_opt);
		EXPECT_EQ(playerPerformance1.hit_post_opt, playerPerformances[0]->hit_post_opt);
		EXPECT_EQ(playerPerformance1.fouls_committed_opt, playerPerformances[0]->fouls_committed_opt);
		EXPECT_EQ(playerPerformance1.fouls_drawn_opt, playerPerformances[0]->fouls_drawn_opt);
		EXPECT_EQ(playerPerformance1.crosses_total_opt, playerPerformances[0]->crosses_total_opt);
		EXPECT_EQ(playerPerformance1.crosses_accurate_opt, playerPerformances[0]->crosses_accurate_opt);
		EXPECT_EQ(playerPerformance1.dribbles_attempts_opt, playerPerformances[0]->dribbles_attempts_opt);
		EXPECT_EQ(playerPerformance1.dribbles_success_opt, playerPerformances[0]->dribbles_success_opt);
		EXPECT_EQ(playerPerformance1.dribbled_past_opt, playerPerformances[0]->dribbled_past_opt);
		EXPECT_EQ(playerPerformance1.duels_total_opt, playerPerformances[0]->duels_total_opt);
		EXPECT_EQ(playerPerformance1.duels_won_opt, playerPerformances[0]->duels_won_opt);
		EXPECT_EQ(playerPerformance1.passes_total_opt, playerPerformances[0]->passes_total_opt);
		EXPECT_EQ(playerPerformance1.passes_accuracy_opt, playerPerformances[0]->passes_accuracy_opt);
		EXPECT_EQ(playerPerformance1.key_passes_opt, playerPerformances[0]->key_passes_opt);
		EXPECT_EQ(playerPerformance1.penalties_won_opt, playerPerformances[0]->penalties_won_opt);
		EXPECT_EQ(playerPerformance1.penalties_scored_opt, playerPerformances[0]->penalties_scored_opt);
		EXPECT_EQ(playerPerformance1.penalties_missed_opt, playerPerformances[0]->penalties_missed_opt);
		EXPECT_EQ(playerPerformance1.penalties_committed_opt, playerPerformances[0]->penalties_committed_opt);
		EXPECT_EQ(playerPerformance1.penalties_saved_opt, playerPerformances[0]->penalties_saved_opt);
		EXPECT_EQ(playerPerformance1.shots_total_opt, playerPerformances[0]->shots_total_opt);
		EXPECT_EQ(playerPerformance1.shots_on_target_opt, playerPerformances[0]->shots_on_target_opt);
		EXPECT_EQ(playerPerformance1.shots_off_target_opt, playerPerformances[0]->shots_off_target_opt);
		
	}
	ASSERT_NO_THROW(InsertOr(OnConflict::Ignore, db, twoplayerPerformances));
	ASSERT_EQ(2, QueryCount<PlayerPerformance>(db));
	{
		auto playerPerformances = QueryAll<PlayerPerformance>(db);
		EXPECT_EQ(2, playerPerformances.size());

		EXPECT_NE(0, playerPerformances[0]->id);
		EXPECT_EQ(playerPerformance1.sm_player_id, playerPerformances[0]->sm_player_id);
		EXPECT_EQ(playerPerformance1.sm_season_id, playerPerformances[0]->sm_season_id);
		EXPECT_EQ(playerPerformance1.sm_team_id, playerPerformances[0]->sm_team_id);
		EXPECT_EQ(playerPerformance1.number, playerPerformances[0]->number);
		EXPECT_EQ(playerPerformance1.captain, playerPerformances[0]->captain);
		EXPECT_EQ(playerPerformance1.injured, playerPerformances[0]->injured);
		EXPECT_EQ(playerPerformance1.minutes, playerPerformances[0]->minutes);
		EXPECT_EQ(playerPerformance1.appearences, playerPerformances[0]->appearences);
		EXPECT_EQ(playerPerformance1.lineups, playerPerformances[0]->lineups);
		EXPECT_EQ(playerPerformance1.substitute_in, playerPerformances[0]->substitute_in);
		EXPECT_EQ(playerPerformance1.substitute_out, playerPerformances[0]->substitute_out);
		EXPECT_EQ(playerPerformance1.substitutes_on_bench, playerPerformances[0]->substitutes_on_bench);
		EXPECT_EQ(playerPerformance1.goals, playerPerformances[0]->goals);
		EXPECT_EQ(playerPerformance1.assists, playerPerformances[0]->assists);
		EXPECT_EQ(playerPerformance1.saves_opt, playerPerformances[0]->saves_opt);
		EXPECT_EQ(playerPerformance1.inside_box_saves_opt, playerPerformances[0]->inside_box_saves_opt);
		EXPECT_EQ(playerPerformance1.dispossesed_opt, playerPerformances[0]->dispossesed_opt);
		EXPECT_EQ(playerPerformance1.interceptions_opt, playerPerformances[0]->interceptions_opt);
		EXPECT_EQ(playerPerformance1.yellowcards, playerPerformances[0]->yellowcards);
		EXPECT_EQ(playerPerformance1.yellowred, playerPerformances[0]->yellowred);
		EXPECT_EQ(playerPerformance1.redcards, playerPerformances[0]->redcards);
		EXPECT_EQ(playerPerformance1.tackles_opt, playerPerformances[0]->tackles_opt);
		EXPECT_EQ(playerPerformance1.blocks_opt, playerPerformances[0]->blocks_opt);
		EXPECT_EQ(playerPerformance1.hit_post_opt, playerPerformances[0]->hit_post_opt);
		EXPECT_EQ(playerPerformance1.fouls_committed_opt, playerPerformances[0]->fouls_committed_opt);
		EXPECT_EQ(playerPerformance1.fouls_drawn_opt, playerPerformances[0]->fouls_drawn_opt);
		EXPECT_EQ(playerPerformance1.crosses_total_opt, playerPerformances[0]->crosses_total_opt);
		EXPECT_EQ(playerPerformance1.crosses_accurate_opt, playerPerformances[0]->crosses_accurate_opt);
		EXPECT_EQ(playerPerformance1.dribbles_attempts_opt, playerPerformances[0]->dribbles_attempts_opt);
		EXPECT_EQ(playerPerformance1.dribbles_success_opt, playerPerformances[0]->dribbles_success_opt);
		EXPECT_EQ(playerPerformance1.dribbled_past_opt, playerPerformances[0]->dribbled_past_opt);
		EXPECT_EQ(playerPerformance1.duels_total_opt, playerPerformances[0]->duels_total_opt);
		EXPECT_EQ(playerPerformance1.duels_won_opt, playerPerformances[0]->duels_won_opt);
		EXPECT_EQ(playerPerformance1.passes_total_opt, playerPerformances[0]->passes_total_opt);
		EXPECT_EQ(playerPerformance1.passes_accuracy_opt, playerPerformances[0]->passes_accuracy_opt);
		EXPECT_EQ(playerPerformance1.key_passes_opt, playerPerformances[0]->key_passes_opt);
		EXPECT_EQ(playerPerformance1.penalties_won_opt, playerPerformances[0]->penalties_won_opt);
		EXPECT_EQ(playerPerformance1.penalties_scored_opt, playerPerformances[0]->penalties_scored_opt);
		EXPECT_EQ(playerPerformance1.penalties_missed_opt, playerPerformances[0]->penalties_missed_opt);
		EXPECT_EQ(playerPerformance1.penalties_committed_opt, playerPerformances[0]->penalties_committed_opt);
		EXPECT_EQ(playerPerformance1.penalties_saved_opt, playerPerformances[0]->penalties_saved_opt);
		EXPECT_EQ(playerPerformance1.shots_total_opt, playerPerformances[0]->shots_total_opt);
		EXPECT_EQ(playerPerformance1.shots_on_target_opt, playerPerformances[0]->shots_on_target_opt);
		EXPECT_EQ(playerPerformance1.shots_off_target_opt, playerPerformances[0]->shots_off_target_opt);
		

		EXPECT_NE(0, playerPerformances[1]->id);
		EXPECT_EQ(playerPerformance2.sm_player_id, playerPerformances[1]->sm_player_id);
		EXPECT_EQ(playerPerformance2.sm_season_id, playerPerformances[1]->sm_season_id);
		EXPECT_EQ(playerPerformance2.sm_team_id, playerPerformances[1]->sm_team_id);
		EXPECT_EQ(playerPerformance2.number, playerPerformances[1]->number);
		EXPECT_EQ(playerPerformance2.captain, playerPerformances[1]->captain);
		EXPECT_EQ(playerPerformance2.injured, playerPerformances[1]->injured);
		EXPECT_EQ(playerPerformance2.minutes, playerPerformances[1]->minutes);
		EXPECT_EQ(playerPerformance2.appearences, playerPerformances[1]->appearences);
		EXPECT_EQ(playerPerformance2.lineups, playerPerformances[1]->lineups);
		EXPECT_EQ(playerPerformance2.substitute_in, playerPerformances[1]->substitute_in);
		EXPECT_EQ(playerPerformance2.substitute_out, playerPerformances[1]->substitute_out);
		EXPECT_EQ(playerPerformance2.substitutes_on_bench, playerPerformances[1]->substitutes_on_bench);
		EXPECT_EQ(playerPerformance2.goals, playerPerformances[1]->goals);
		EXPECT_EQ(playerPerformance2.assists, playerPerformances[1]->assists);
		EXPECT_EQ(playerPerformance2.saves_opt, playerPerformances[1]->saves_opt);
		EXPECT_EQ(playerPerformance2.inside_box_saves_opt, playerPerformances[1]->inside_box_saves_opt);
		EXPECT_EQ(playerPerformance2.dispossesed_opt, playerPerformances[1]->dispossesed_opt);
		EXPECT_EQ(playerPerformance2.interceptions_opt, playerPerformances[1]->interceptions_opt);
		EXPECT_EQ(playerPerformance2.yellowcards, playerPerformances[1]->yellowcards);
		EXPECT_EQ(playerPerformance2.yellowred, playerPerformances[1]->yellowred);
		EXPECT_EQ(playerPerformance2.redcards, playerPerformances[1]->redcards);
		EXPECT_EQ(playerPerformance2.tackles_opt, playerPerformances[1]->tackles_opt);
		EXPECT_EQ(playerPerformance2.blocks_opt, playerPerformances[1]->blocks_opt);
		EXPECT_EQ(playerPerformance2.hit_post_opt, playerPerformances[1]->hit_post_opt);
		EXPECT_EQ(playerPerformance2.fouls_committed_opt, playerPerformances[1]->fouls_committed_opt);
		EXPECT_EQ(playerPerformance2.fouls_drawn_opt, playerPerformances[1]->fouls_drawn_opt);
		EXPECT_EQ(playerPerformance2.crosses_total_opt, playerPerformances[1]->crosses_total_opt);
		EXPECT_EQ(playerPerformance2.crosses_accurate_opt, playerPerformances[1]->crosses_accurate_opt);
		EXPECT_EQ(playerPerformance2.dribbles_attempts_opt, playerPerformances[1]->dribbles_attempts_opt);
		EXPECT_EQ(playerPerformance2.dribbles_success_opt, playerPerformances[1]->dribbles_success_opt);
		EXPECT_EQ(playerPerformance2.dribbled_past_opt, playerPerformances[1]->dribbled_past_opt);
		EXPECT_EQ(playerPerformance2.duels_total_opt, playerPerformances[1]->duels_total_opt);
		EXPECT_EQ(playerPerformance2.duels_won_opt, playerPerformances[1]->duels_won_opt);
		EXPECT_EQ(playerPerformance2.passes_total_opt, playerPerformances[1]->passes_total_opt);
		EXPECT_EQ(playerPerformance2.passes_accuracy_opt, playerPerformances[1]->passes_accuracy_opt);
		EXPECT_EQ(playerPerformance2.key_passes_opt, playerPerformances[1]->key_passes_opt);
		EXPECT_EQ(playerPerformance2.penalties_won_opt, playerPerformances[1]->penalties_won_opt);
		EXPECT_EQ(playerPerformance2.penalties_scored_opt, playerPerformances[1]->penalties_scored_opt);
		EXPECT_EQ(playerPerformance2.penalties_missed_opt, playerPerformances[1]->penalties_missed_opt);
		EXPECT_EQ(playerPerformance2.penalties_committed_opt, playerPerformances[1]->penalties_committed_opt);
		EXPECT_EQ(playerPerformance2.penalties_saved_opt, playerPerformances[1]->penalties_saved_opt);
		EXPECT_EQ(playerPerformance2.shots_total_opt, playerPerformances[1]->shots_total_opt);
		EXPECT_EQ(playerPerformance2.shots_on_target_opt, playerPerformances[1]->shots_on_target_opt);
		EXPECT_EQ(playerPerformance2.shots_off_target_opt, playerPerformances[1]->shots_off_target_opt);
		
	}
	ASSERT_NO_THROW(InsertOr(OnConflict::Ignore, db, threeplayerPerformances));
	ASSERT_EQ(3, QueryCount<PlayerPerformance>(db));
	{
		auto playerPerformances = QueryAll<PlayerPerformance>(db);
		EXPECT_EQ(3, playerPerformances.size());

		EXPECT_NE(0, playerPerformances[0]->id);
		EXPECT_EQ(playerPerformance1.sm_player_id, playerPerformances[0]->sm_player_id);
		EXPECT_EQ(playerPerformance1.sm_season_id, playerPerformances[0]->sm_season_id);
		EXPECT_EQ(playerPerformance1.sm_team_id, playerPerformances[0]->sm_team_id);
		EXPECT_EQ(playerPerformance1.number, playerPerformances[0]->number);
		EXPECT_EQ(playerPerformance1.captain, playerPerformances[0]->captain);
		EXPECT_EQ(playerPerformance1.injured, playerPerformances[0]->injured);
		EXPECT_EQ(playerPerformance1.minutes, playerPerformances[0]->minutes);
		EXPECT_EQ(playerPerformance1.appearences, playerPerformances[0]->appearences);
		EXPECT_EQ(playerPerformance1.lineups, playerPerformances[0]->lineups);
		EXPECT_EQ(playerPerformance1.substitute_in, playerPerformances[0]->substitute_in);
		EXPECT_EQ(playerPerformance1.substitute_out, playerPerformances[0]->substitute_out);
		EXPECT_EQ(playerPerformance1.substitutes_on_bench, playerPerformances[0]->substitutes_on_bench);
		EXPECT_EQ(playerPerformance1.goals, playerPerformances[0]->goals);
		EXPECT_EQ(playerPerformance1.assists, playerPerformances[0]->assists);
		EXPECT_EQ(playerPerformance1.saves_opt, playerPerformances[0]->saves_opt);
		EXPECT_EQ(playerPerformance1.inside_box_saves_opt, playerPerformances[0]->inside_box_saves_opt);
		EXPECT_EQ(playerPerformance1.dispossesed_opt, playerPerformances[0]->dispossesed_opt);
		EXPECT_EQ(playerPerformance1.interceptions_opt, playerPerformances[0]->interceptions_opt);
		EXPECT_EQ(playerPerformance1.yellowcards, playerPerformances[0]->yellowcards);
		EXPECT_EQ(playerPerformance1.yellowred, playerPerformances[0]->yellowred);
		EXPECT_EQ(playerPerformance1.redcards, playerPerformances[0]->redcards);
		EXPECT_EQ(playerPerformance1.tackles_opt, playerPerformances[0]->tackles_opt);
		EXPECT_EQ(playerPerformance1.blocks_opt, playerPerformances[0]->blocks_opt);
		EXPECT_EQ(playerPerformance1.hit_post_opt, playerPerformances[0]->hit_post_opt);
		EXPECT_EQ(playerPerformance1.fouls_committed_opt, playerPerformances[0]->fouls_committed_opt);
		EXPECT_EQ(playerPerformance1.fouls_drawn_opt, playerPerformances[0]->fouls_drawn_opt);
		EXPECT_EQ(playerPerformance1.crosses_total_opt, playerPerformances[0]->crosses_total_opt);
		EXPECT_EQ(playerPerformance1.crosses_accurate_opt, playerPerformances[0]->crosses_accurate_opt);
		EXPECT_EQ(playerPerformance1.dribbles_attempts_opt, playerPerformances[0]->dribbles_attempts_opt);
		EXPECT_EQ(playerPerformance1.dribbles_success_opt, playerPerformances[0]->dribbles_success_opt);
		EXPECT_EQ(playerPerformance1.dribbled_past_opt, playerPerformances[0]->dribbled_past_opt);
		EXPECT_EQ(playerPerformance1.duels_total_opt, playerPerformances[0]->duels_total_opt);
		EXPECT_EQ(playerPerformance1.duels_won_opt, playerPerformances[0]->duels_won_opt);
		EXPECT_EQ(playerPerformance1.passes_total_opt, playerPerformances[0]->passes_total_opt);
		EXPECT_EQ(playerPerformance1.passes_accuracy_opt, playerPerformances[0]->passes_accuracy_opt);
		EXPECT_EQ(playerPerformance1.key_passes_opt, playerPerformances[0]->key_passes_opt);
		EXPECT_EQ(playerPerformance1.penalties_won_opt, playerPerformances[0]->penalties_won_opt);
		EXPECT_EQ(playerPerformance1.penalties_scored_opt, playerPerformances[0]->penalties_scored_opt);
		EXPECT_EQ(playerPerformance1.penalties_missed_opt, playerPerformances[0]->penalties_missed_opt);
		EXPECT_EQ(playerPerformance1.penalties_committed_opt, playerPerformances[0]->penalties_committed_opt);
		EXPECT_EQ(playerPerformance1.penalties_saved_opt, playerPerformances[0]->penalties_saved_opt);
		EXPECT_EQ(playerPerformance1.shots_total_opt, playerPerformances[0]->shots_total_opt);
		EXPECT_EQ(playerPerformance1.shots_on_target_opt, playerPerformances[0]->shots_on_target_opt);
		EXPECT_EQ(playerPerformance1.shots_off_target_opt, playerPerformances[0]->shots_off_target_opt);
		

		EXPECT_NE(0, playerPerformances[1]->id);
		EXPECT_EQ(playerPerformance2.sm_player_id, playerPerformances[1]->sm_player_id);
		EXPECT_EQ(playerPerformance2.sm_season_id, playerPerformances[1]->sm_season_id);
		EXPECT_EQ(playerPerformance2.sm_team_id, playerPerformances[1]->sm_team_id);
		EXPECT_EQ(playerPerformance2.number, playerPerformances[1]->number);
		EXPECT_EQ(playerPerformance2.captain, playerPerformances[1]->captain);
		EXPECT_EQ(playerPerformance2.injured, playerPerformances[1]->injured);
		EXPECT_EQ(playerPerformance2.minutes, playerPerformances[1]->minutes);
		EXPECT_EQ(playerPerformance2.appearences, playerPerformances[1]->appearences);
		EXPECT_EQ(playerPerformance2.lineups, playerPerformances[1]->lineups);
		EXPECT_EQ(playerPerformance2.substitute_in, playerPerformances[1]->substitute_in);
		EXPECT_EQ(playerPerformance2.substitute_out, playerPerformances[1]->substitute_out);
		EXPECT_EQ(playerPerformance2.substitutes_on_bench, playerPerformances[1]->substitutes_on_bench);
		EXPECT_EQ(playerPerformance2.goals, playerPerformances[1]->goals);
		EXPECT_EQ(playerPerformance2.assists, playerPerformances[1]->assists);
		EXPECT_EQ(playerPerformance2.saves_opt, playerPerformances[1]->saves_opt);
		EXPECT_EQ(playerPerformance2.inside_box_saves_opt, playerPerformances[1]->inside_box_saves_opt);
		EXPECT_EQ(playerPerformance2.dispossesed_opt, playerPerformances[1]->dispossesed_opt);
		EXPECT_EQ(playerPerformance2.interceptions_opt, playerPerformances[1]->interceptions_opt);
		EXPECT_EQ(playerPerformance2.yellowcards, playerPerformances[1]->yellowcards);
		EXPECT_EQ(playerPerformance2.yellowred, playerPerformances[1]->yellowred);
		EXPECT_EQ(playerPerformance2.redcards, playerPerformances[1]->redcards);
		EXPECT_EQ(playerPerformance2.tackles_opt, playerPerformances[1]->tackles_opt);
		EXPECT_EQ(playerPerformance2.blocks_opt, playerPerformances[1]->blocks_opt);
		EXPECT_EQ(playerPerformance2.hit_post_opt, playerPerformances[1]->hit_post_opt);
		EXPECT_EQ(playerPerformance2.fouls_committed_opt, playerPerformances[1]->fouls_committed_opt);
		EXPECT_EQ(playerPerformance2.fouls_drawn_opt, playerPerformances[1]->fouls_drawn_opt);
		EXPECT_EQ(playerPerformance2.crosses_total_opt, playerPerformances[1]->crosses_total_opt);
		EXPECT_EQ(playerPerformance2.crosses_accurate_opt, playerPerformances[1]->crosses_accurate_opt);
		EXPECT_EQ(playerPerformance2.dribbles_attempts_opt, playerPerformances[1]->dribbles_attempts_opt);
		EXPECT_EQ(playerPerformance2.dribbles_success_opt, playerPerformances[1]->dribbles_success_opt);
		EXPECT_EQ(playerPerformance2.dribbled_past_opt, playerPerformances[1]->dribbled_past_opt);
		EXPECT_EQ(playerPerformance2.duels_total_opt, playerPerformances[1]->duels_total_opt);
		EXPECT_EQ(playerPerformance2.duels_won_opt, playerPerformances[1]->duels_won_opt);
		EXPECT_EQ(playerPerformance2.passes_total_opt, playerPerformances[1]->passes_total_opt);
		EXPECT_EQ(playerPerformance2.passes_accuracy_opt, playerPerformances[1]->passes_accuracy_opt);
		EXPECT_EQ(playerPerformance2.key_passes_opt, playerPerformances[1]->key_passes_opt);
		EXPECT_EQ(playerPerformance2.penalties_won_opt, playerPerformances[1]->penalties_won_opt);
		EXPECT_EQ(playerPerformance2.penalties_scored_opt, playerPerformances[1]->penalties_scored_opt);
		EXPECT_EQ(playerPerformance2.penalties_missed_opt, playerPerformances[1]->penalties_missed_opt);
		EXPECT_EQ(playerPerformance2.penalties_committed_opt, playerPerformances[1]->penalties_committed_opt);
		EXPECT_EQ(playerPerformance2.penalties_saved_opt, playerPerformances[1]->penalties_saved_opt);
		EXPECT_EQ(playerPerformance2.shots_total_opt, playerPerformances[1]->shots_total_opt);
		EXPECT_EQ(playerPerformance2.shots_on_target_opt, playerPerformances[1]->shots_on_target_opt);
		EXPECT_EQ(playerPerformance2.shots_off_target_opt, playerPerformances[1]->shots_off_target_opt);
		

		EXPECT_NE(0, playerPerformances[2]->id);
		EXPECT_EQ(playerPerformance3.sm_player_id, playerPerformances[2]->sm_player_id);
		EXPECT_EQ(playerPerformance3.sm_season_id, playerPerformances[2]->sm_season_id);
		EXPECT_EQ(playerPerformance3.sm_team_id, playerPerformances[2]->sm_team_id);
		EXPECT_EQ(playerPerformance3.number, playerPerformances[2]->number);
		EXPECT_EQ(playerPerformance3.captain, playerPerformances[2]->captain);
		EXPECT_EQ(playerPerformance3.injured, playerPerformances[2]->injured);
		EXPECT_EQ(playerPerformance3.minutes, playerPerformances[2]->minutes);
		EXPECT_EQ(playerPerformance3.appearences, playerPerformances[2]->appearences);
		EXPECT_EQ(playerPerformance3.lineups, playerPerformances[2]->lineups);
		EXPECT_EQ(playerPerformance3.substitute_in, playerPerformances[2]->substitute_in);
		EXPECT_EQ(playerPerformance3.substitute_out, playerPerformances[2]->substitute_out);
		EXPECT_EQ(playerPerformance3.substitutes_on_bench, playerPerformances[2]->substitutes_on_bench);
		EXPECT_EQ(playerPerformance3.goals, playerPerformances[2]->goals);
		EXPECT_EQ(playerPerformance3.assists, playerPerformances[2]->assists);
		EXPECT_EQ(playerPerformance3.saves_opt, playerPerformances[2]->saves_opt);
		EXPECT_EQ(playerPerformance3.inside_box_saves_opt, playerPerformances[2]->inside_box_saves_opt);
		EXPECT_EQ(playerPerformance3.dispossesed_opt, playerPerformances[2]->dispossesed_opt);
		EXPECT_EQ(playerPerformance3.interceptions_opt, playerPerformances[2]->interceptions_opt);
		EXPECT_EQ(playerPerformance3.yellowcards, playerPerformances[2]->yellowcards);
		EXPECT_EQ(playerPerformance3.yellowred, playerPerformances[2]->yellowred);
		EXPECT_EQ(playerPerformance3.redcards, playerPerformances[2]->redcards);
		EXPECT_EQ(playerPerformance3.tackles_opt, playerPerformances[2]->tackles_opt);
		EXPECT_EQ(playerPerformance3.blocks_opt, playerPerformances[2]->blocks_opt);
		EXPECT_EQ(playerPerformance3.hit_post_opt, playerPerformances[2]->hit_post_opt);
		EXPECT_EQ(playerPerformance3.fouls_committed_opt, playerPerformances[2]->fouls_committed_opt);
		EXPECT_EQ(playerPerformance3.fouls_drawn_opt, playerPerformances[2]->fouls_drawn_opt);
		EXPECT_EQ(playerPerformance3.crosses_total_opt, playerPerformances[2]->crosses_total_opt);
		EXPECT_EQ(playerPerformance3.crosses_accurate_opt, playerPerformances[2]->crosses_accurate_opt);
		EXPECT_EQ(playerPerformance3.dribbles_attempts_opt, playerPerformances[2]->dribbles_attempts_opt);
		EXPECT_EQ(playerPerformance3.dribbles_success_opt, playerPerformances[2]->dribbles_success_opt);
		EXPECT_EQ(playerPerformance3.dribbled_past_opt, playerPerformances[2]->dribbled_past_opt);
		EXPECT_EQ(playerPerformance3.duels_total_opt, playerPerformances[2]->duels_total_opt);
		EXPECT_EQ(playerPerformance3.duels_won_opt, playerPerformances[2]->duels_won_opt);
		EXPECT_EQ(playerPerformance3.passes_total_opt, playerPerformances[2]->passes_total_opt);
		EXPECT_EQ(playerPerformance3.passes_accuracy_opt, playerPerformances[2]->passes_accuracy_opt);
		EXPECT_EQ(playerPerformance3.key_passes_opt, playerPerformances[2]->key_passes_opt);
		EXPECT_EQ(playerPerformance3.penalties_won_opt, playerPerformances[2]->penalties_won_opt);
		EXPECT_EQ(playerPerformance3.penalties_scored_opt, playerPerformances[2]->penalties_scored_opt);
		EXPECT_EQ(playerPerformance3.penalties_missed_opt, playerPerformances[2]->penalties_missed_opt);
		EXPECT_EQ(playerPerformance3.penalties_committed_opt, playerPerformances[2]->penalties_committed_opt);
		EXPECT_EQ(playerPerformance3.penalties_saved_opt, playerPerformances[2]->penalties_saved_opt);
		EXPECT_EQ(playerPerformance3.shots_total_opt, playerPerformances[2]->shots_total_opt);
		EXPECT_EQ(playerPerformance3.shots_on_target_opt, playerPerformances[2]->shots_on_target_opt);
		EXPECT_EQ(playerPerformance3.shots_off_target_opt, playerPerformances[2]->shots_off_target_opt);
		
	}
}